//Sumair Sawhney
//sss323
//Individual Project - Secret Safe

//Description:
/*
   The Secret Safe a series of short and long presses to a buttonas a code to unlock the safe.
   It also utilizes a hidden photoresistor as a means to unlock a secret. When the photoresistor is covered
   and the code button is pressed again, the secret compartment unlocks.
*/
#include <Servo.h>


//Create all variables and pins
Servo mainServo;
Servo secretServo;
int mainServoPin = 9;
int secretServoPin = 10;
int codeButtonPin = 6;
int lockButtonPin = 5;
int redLightPin = 8;
int greenLightPin = 7;
int ldrPin = A5;
int threshold = 300;
bool locked = true;
bool secretCompLocked = true;
String input = "";
char code[] = "sls";
void setup()
{
  //Setup pins and servos, set servos to default position
  Serial.begin(9600);
  pinMode(codeButtonPin, INPUT);
  pinMode(lockButtonPin, INPUT);
  pinMode(ldrPin, INPUT);
  pinMode(redLightPin, OUTPUT);
  pinMode(greenLightPin, OUTPUT);
  mainServo.attach(mainServoPin);
  secretServo.attach(secretServoPin);
  mainServo.write(0);
  secretServo.write(0);

}

void loop()
{
  //Serial.println(threshold);
  Serial.println(analogRead(ldrPin));
  //if the safe is locked, read in code inputs and check for submit
  if (locked) {
    if (digitalRead(codeButtonPin) == LOW) {
      delay(200);
      if (digitalRead(codeButtonPin) == HIGH) {
        delay(250);
        //once the input button is pressed, uses a delay to determine if it is still pressed and relates it to the respective long or short input code
        if (digitalRead(codeButtonPin) == HIGH) {
          Serial.println("long");
          input = input + "l";
          digitalWrite(greenLightPin , HIGH);
          delay(300);
        }
        else {
          Serial.println("short");
          input = input + "s";
          digitalWrite(greenLightPin, HIGH);
          delay(100);
        }
        digitalWrite(greenLightPin, LOW);
        Serial.println(input);
      }
      //if the unlock button is pressed, check if the correct code matches the input
      if (digitalRead(lockButtonPin) == HIGH) {
        checkCode();
      }
    }
  }
  //if the same is unlocked, check for the secret compartment unlock and for the re-lock command
  else {

    //if the code button is pressed when unlocked and the light detects a low light level, unlock the secret compartment
    if (digitalRead(codeButtonPin) == HIGH) {
      if (threshold - 100 >= 0 && analogRead(ldrPin) < threshold - 100) {
        delay(500);
        secretCompLocked = false;
        secretServo.write(100);
        Serial.println("Unlock Secret Compartment");

      }
    }
    if (digitalRead(lockButtonPin) == HIGH) {
      // if the lock button is pressed, lock the safe
      Serial.println("Lock");
      if (!secretCompLocked) {
        secretCompLocked = true;
        secretServo.write(0);
      }
      digitalWrite(redLightPin, HIGH);
      locked = true;
      mainServo.write(0);
      delay(500);
      digitalWrite(redLightPin, LOW);
      flashLED(redLightPin);
    }


  }
}

//function to check if code matches pre-programmed combination
void checkCode() {

  if (input == code) {
    flashLED(greenLightPin);
    Serial.println("Unlocked");
    locked = false;
    input = "";
    mainServo.write(100);
    //sets the threshold as the current light level when unlocked as light level might not be consistent throughout day
    threshold = int(analogRead(ldrPin));
    delay(500);
  }
  else {
    flashLED(redLightPin);
    Serial.println("Incorrect Password");
    input = "";
  }
}

//function to flash an LED
void flashLED(int pin) {
  digitalWrite(pin, HIGH);
  delay(100);
  digitalWrite(pin, LOW);
  delay(100);
  digitalWrite(pin, HIGH);
  delay(100);
  digitalWrite(pin, LOW);
  delay(100);
  digitalWrite(pin, HIGH);
  delay(100);
  digitalWrite(pin, LOW);
  delay(200);
}
